--[[
	This file is part of FlexBar2.

	FlexBar2 is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	FlexBar2 is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with FlexBar2.  If not, see <http://www.gnu.org/licenses/>.
]]
-- SlashCommands --

-- /fb settext command
local function SlashCommand_SetText(Params)
	local ButtonTable = FlexBar2:ToButtonTable(Params.button);
	local Field = tonumber(Params.field);
	local Text = Params.text;
	local ButtonList = FlexBar2.Buttons;
	for _, ButtonName in ipairs(ButtonTable) do
		local Button = ButtonList[ButtonName];
		Button.InfoTable.TextSubs[Field] = Text;
		Button:SetTextField(Field, Text);
	end
end

local SlashCommands = FlexBar2.SlashCommands;
-- Localize this neat verify function for faster access
local VerifyExistance = FlexBar2.SlashCommands.VerifyExistance;
-- AddCommand format :AddCommand(Command, Function, Group, Help)
-- AddParam format :AddParam(Command, Param, Required, AllowedValues, DefaultValue, VerifyFunc) 
-- everything here should be self explainative knowing the syntax
SlashCommands:AddCommand("settext", SlashCommand_SetText, "text", "button=<Button> field=<1-5> text=<text>");
SlashCommands:SetAlias("settext", "text");
	SlashCommands:AddParam("settext", "button", true, nil, nil, VerifyExistance);
	SlashCommands:AddParam("settext", "field", true, {"1", "2", "3", "4", "5"}, nil, nil);
	SlashCommands:AddParam("settext", "text", true, nil, nil, nil);
